﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Services.Description;
using System.Runtime.Serialization;
using System.IO;
namespace DataContractSerializerExample
{
    [DataContract(IsReference = false)]
    public class Person
    {
        public Person(string firstName, string lastName, Person parent)
        {
            FirstName = firstName;
            LastName = lastName;
            // this is a SELF reference - A reference to a member (children, who are also PERSONS) in the same object (person)
            Children = new List<Person>();
            Parent = parent;
        }

        // In older WCF, this would throw an exception during serialization (due to the self reference)
        [DataMember]
        public string FirstName { get; set; }
        [DataMember]
        public string LastName { get; set; }
        [DataMember]
        public List<Person> Children { get; set; }
        [DataMember]
        public Person Parent { get; set; }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Person AV = new Person("A", "V", null);
            // this is a SELF reference - A reference to a member (children, who are also PERSONS) in the same object (person)
            AV.Children.Add(new Person("offspring1", "one", AV));
            AV.Children.Add(new Person("offspring2", "two", AV));

            try
            {
                DataContractSerializer dcs = new DataContractSerializer(typeof(Person));
                MemoryStream stream = new MemoryStream();
                dcs.WriteObject(stream, AV);
            }
            catch (Exception ex)
            {
                Console.WriteLine("An exception occured: " + ex.Message);
            }
        }
    }
}
